// Base class of all Vehicle classes. (Created by .:..: 8.1.2008)
Class Vehicle extends VActor
	Abstract
	Config(User);

#exec AUDIO IMPORT FILE="Sounds\CarAlarm01.wav" NAME="CarAlarm01" GROUP="Vehicles"
#exec AUDIO IMPORT FILE="Sounds\Hijacked.wav" NAME="Hijacked" GROUP="Vehicles"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision01.WAV" NAME="VehicleCollision01" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision02.WAV" NAME="VehicleCollision02" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision03.WAV" NAME="VehicleCollision03" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision04.WAV" NAME="VehicleCollision04" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision05.WAV" NAME="VehicleCollision05" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision06.WAV" NAME="VehicleCollision06" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleCollision07.WAV" NAME="VehicleCollision07" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet01.WAV" NAME="VehicleHitBullet01" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet02.WAV" NAME="VehicleHitBullet02" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet03.WAV" NAME="VehicleHitBullet03" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet04.WAV" NAME="VehicleHitBullet04" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet05.WAV" NAME="VehicleHitBullet05" GROUP="Impacts"
#exec AUDIO IMPORT FILE="Sounds\VehicleHitBullet06.WAV" NAME="VehicleHitBullet06" GROUP="Impacts"
#exec Texture Import File=NO.bmp Name=IconNoEnter MIPS=off FLAGS=2 TEXFLAGS=0 GROUP="HUD"
#exec Texture Import File=CorrectAim.bmp Name=CrCorrectAim MIPS=off FLAGS=2 TEXFLAGS=0 GROUP="HUD"
#exec Texture Import File=BorderBoxD.pcx Name=BorderBoxD MIPS=off FLAGS=2 TEXFLAGS=0 GROUP="HUD"
#exec Texture Import File=HealthBar.pcx Name=HealthBar MIPS=off FLAGS=2 TEXFLAGS=0 GROUP="HUD"

var() float AIRating,VehicleGravityScale,WAccelRate,NextWaterDamageTime;
var() int Health;
var() class<VAIBehaviour> AIClass;
var() class<DriverWeapon> DriverWeaponClass;
var() bool bTeamLocked,bShouldRepVehYaw,bFPViewUseRelRot,bFPRepYawUpdatesView,bStationaryTurret,bRenderVehicleOnFP,bIsWaterResistant;
var() byte CurrentTeam;
var() localized string VehicleName,TranslatorDescription,MsgVehicleDesc;
var() vector ExitOffset,BehinViewViewOffset,InsideViewOffset;
var(Sounds) sound StartSound,EndSound,EngineSound,IdleSound,ImpactSounds[8],BulletHitSounds[6];
var() config bool bUseBehindView;
var() texture TeamOverlays[4],AimLockedOnCrosshairTex;
struct WepInfoType
{
	var() class<WeaponAttachment> WeaponClass;
	var() vector WeaponOffset;
	var() bool bInvisibleGun;
};
var() WepInfoType DriverWeapon;
struct PassengersType
{
	var() class<WeaponAttachment> PassengerWeapon; // The weapon class for this passenger (None if nothing)
	var() bool bPassengerWInvis; // For passenger weapon
	var() vector PassengerWOffset; // For passenger weapon
	var() vector CameraOffset; // Camera origin offset (from weapon offset)!
	var() vector CamBehindviewOffset; // Camera behindview offset
	var() bool bIsAvailable; // Set to true if this passenger slot is useable.
	var() string SeatName;
	var WeaponAttachment PGun;
	var DriverWeapon PHGun;
	var PassengerCameraA PassengerCam;
};
var() PassengersType PassengerSeats[8];

struct OverlayMatDispRep
{
	var Texture MatTexture;
	var byte MatDispTime;
};
var VAIBehaviour VehicleAI;
var DriverWeapon DWeapon;
var Texture OverlayMat;
var float OverlayTime,OverlayResetTime;
var bool bResetOLRep;
var WeaponAttachment DriverGun;

var Vehicle PendingBump;

// -1 to 1.
var int Turning,Rising,Accel;
var int VehicleYaw,ReplVehicleYaw;

// Driving pawn
var Pawn Driver,Passengers[8];

var vector FloorNormal,ActualFloorNormal;
var VehicleAttachment AttachmentList; // Vehicle attachment list.
var bool bDriving,bOnGround,bCameraOnBehindView,bVehicleBlewUp,bClientBlewUp,bHadADriver;
var float ResetTimer;
var BotAttractInv BotAttract;

// Bot info
var bool bHasMoveTarget;
var vector MoveDest;
var float MoveTimer;

// Replication variables
var vector VehPos,VehVeloc,SimVehVeloc,SimPosUpd;
var bool bUpdatingPos;
var byte UpdTimeLeft;
var DriverCameraActor MyCameraAct;
var OverlayMatDispRep ReplicOverlayMat;

var VehicleFactory MyFactory;
var const EPhysics ReqPPPhysics;

// Full vehicles keys display info, write it in form like this: "Press %MoveForward to accelerate|Press %Fire to Fire weapon"
var(Info) localized string VehicleKeyInfoStr;
var string KeysInfo[16];
var byte NumKeysInfo;
var bool bHasInitKeysInfo,bActorKeysInit;

replication
{
	// Variables the server should send to the client.
	reliable if( Role==ROLE_Authority )
		VehPos,VehVeloc,Driver,bDriving,Health,bVehicleBlewUp,ReplicOverlayMat,bTeamLocked,CurrentTeam,Passengers;
	reliable if( Role==ROLE_Authority && bNetOwner )
		bCameraOnBehindView,MyCameraAct,WAccelRate,DriverGun;
	reliable if( Role==ROLE_Authority && bShouldRepVehYaw )
		ReplVehicleYaw;
	// Functions client can call.
	reliable if( Role<ROLE_Authority )
		ServerPreformMove,ServerSetBehindView;
	// Functions server can call.
	reliable if( Role==ROLE_Authority )
		ClientSetTranslatorMsg;
}

simulated function InitKeysInfo()
{
	local int i,j;
	local string S,Ch,Ks;
	local bool bLoopOK;

	if( !Default.bHasInitKeysInfo )
	{
		Default.bHasInitKeysInfo = True;
		S = VehicleKeyInfoStr;
		While( !bLoopOK )
		{
			i = InStr(S,"|");
			if( i==-1 )
			{
				bLoopOK = True;
				Ch = S;
			}
			else
			{
				Ch = Left(S,i);
				S = Mid(S,i+1);
			}
			i = InStr(Ch,"%");
			if( i!=-1 )
			{
				Ks = Mid(Ch,i+1);
				j = InStr(Ks,"%");
				if( j!=-1 )
					Ks = Left(Ks,j);
				else j = 0;
				Ks = Class'KeyBindObject'.Static.FindKeyBinding(Ks,Self);
				if( Ks=="" )
					Continue;
				Ch = Left(Ch,i)$Ks$Mid(Ch,j+i+2);
				i = InStr(Ch,"%");
				While( i>0 )
				{
					Ks = Mid(Ch,i+1);
					j = InStr(Ks,"%");
					if( j!=-1 )
						Ks = Left(Ks,j);
					else j = 0;
					Ks = Class'KeyBindObject'.Static.FindKeyBinding(Ks,Self);
					Ch = Left(Ch,i)$Ks$Mid(Ch,j+i+2);
					i = InStr(Ch,"%");
				}
			}
			Default.KeysInfo[Default.NumKeysInfo] = Ch;
			if( (++Default.NumKeysInfo)==ArrayCount(KeysInfo) )
				bLoopOK = True;
		}
	}
	bActorKeysInit = True;
	NumKeysInfo = Default.NumKeysInfo;
	For( i=0; i<NumKeysInfo; i++ )
		KeysInfo[i] = Default.KeysInfo[i];
}
simulated function PostBeginPlay()
{
	local byte i;

	if( Level.NetMode!=NM_Client )
	{
		VehicleYaw = Rotation.Yaw;
		if( VehicleAI==None )
		{
			if( AIClass==None )
				AIClass = Class'VAIBehaviour';
			VehicleAI = Spawn(AIClass);
			if( VehicleAI==None )
			{
				Error("Failed to spawn Vehicle AI");
				Return;
			}
			VehicleAI.VehicleOwner = Self;
		}
		if( DWeapon==None )
		{
			if( DriverWeaponClass==None )
				DriverWeaponClass = Class'DriverWeapon';
			DWeapon = Spawn(DriverWeaponClass,Self);
			DWeapon.VehicleOwner = Self;
		}
		if( MyCameraAct==None )
			MyCameraAct = Spawn(Class'DriverCameraActor',Self);
		if( DriverGun==None && DriverWeapon.WeaponClass!=None )
		{
			DriverGun = WeaponAttachment(AddAttachment(DriverWeapon.WeaponClass));
			if( DriverGun!=None )
			{
				DriverGun.bDriverWeapon = True;
				DriverGun.bInvisGun = DriverWeapon.bInvisibleGun;
				DriverGun.TurretOffset = DriverWeapon.WeaponOffset;
			}
		}
		For( i=0; i<ArrayCount(PassengerSeats); i++ )
		{
			if( PassengerSeats[i].bIsAvailable )
			{
				if( PassengerSeats[i].PGun==None && PassengerSeats[i].PassengerWeapon!=None )
				{
					PassengerSeats[i].PGun = WeaponAttachment(AddAttachment(PassengerSeats[i].PassengerWeapon));
					if( PassengerSeats[i].PGun!=None )
					{
						PassengerSeats[i].PGun.SetOwner(None);
						PassengerSeats[i].PGun.bInvisGun = PassengerSeats[i].bPassengerWInvis;
						PassengerSeats[i].PGun.TurretOffset = PassengerSeats[i].PassengerWOffset;
						PassengerSeats[i].PGun.PassengerNum = i+1;
					}
				}
			}
		}
	}
}

// Owner pressed fire
function FireWeapon( bool bAltFire )
{
	local byte i;

	if( bAltFire )
		i = 1;
	if( DriverGun!=None )
		DriverGun.FireTurret(i);
}

// Return normal for acceleration direction.
simulated function vector GetAccelDir( int InTurn, int InRise, int InAccel )
{
	Return vector(Rotation)*InAccel;
}

// Client -> Server, the players movement keys pressed.
function ServerPreformMove( byte InRise, byte InTurn, byte InAccel )
{
	Turning = int(InTurn)-1;
	Rising = int(InRise)-1;
	Accel = int(InAccel)-1;
	if( Turning>1 )
		Turning = 1;
	if( Rising>1 )
		Rising = 1;
	if( Accel>1 )
		Accel = 1;
}

function DriverEnter( Pawn Other )
{
	local rotator R;

	bHadADriver = True;
	Other.DrawScale = 0;
	bTeamLocked = False;
	Driver = Other;
	SetOwner(Other);
	Instigator = Other;
	PlaySound(StartSound,SLOT_Misc);
	AmbientSound = EngineSound;
	Other.SetCollision(False,False,False);
	Other.SetCollisionSize(0,0);
	if( DriverGun!=None )
		DriverGun.WeaponController = Other;
	if( DWeapon==None )
	{
		DWeapon = Spawn(DriverWeaponClass,Self);
		DWeapon.VehicleOwner = Self;
	}
	DWeapon.NotifyNewDriver(Other);
	DWeapon.SetOwner(Other);
	if( Other.Weapon!=None )
	{
		Other.PendingWeapon = Other.Weapon;
		Other.Weapon.GoToState('');
	}
	Other.Weapon = DWeapon;
	if( PlayerPawn(Other)!=None )
	{
		ClientSetTranslatorMsg();
		R.Yaw = VehicleYaw;
		R.Pitch = -4000;
		PlayerPawn(Other).ClientSetRotation(R);
		PlayerPawn(Other).ViewTarget = MyCameraAct;
		PlayerPawn(Other).bBehindView = False;
		if( Other.PlayerReplicationInfo!=None && Other.PlayerReplicationInfo.HasFlag!=None )
			Other.GoToState('FeigningDeath');
		Other.GoToState('PlayerFlying');
	}
	GoToState('VehicleDriving');
}
function DriverLeft( optional bool bForcedLeave )
{
	if( Driver!=None )
	{
		if( Driver.bDeleteMe )
			Driver = None;
		else
		{
			Driver.DrawScale = Driver.Default.DrawScale;
			if( PlayerPawn(Driver)!=None && Driver.Health>0 )
				Driver.GoToState('PlayerWalking');
			if( PlayerPawn(Driver)!=None )
				Driver.ClientRestart();
			Driver.SetCollision(True,False,False);
			Driver.SetCollisionSize(Driver.Default.CollisionRadius,Driver.Default.CollisionHeight);
			if( !bForcedLeave && !Driver.SetLocation(Location+(ExitOffset >> Rotation)) )
			{
				Driver.SetCollision(False,False,False);
				Driver.SetCollisionSize(0,0);
				if( PlayerPawn(Driver)!=None )
					Driver.GoToState('PlayerFlying');
				Return;
			}
			Driver.SetCollision(True,True,True);
			if( PlayerPawn(Driver)!=None )
			{
				PlayerPawn(Driver).ViewTarget = None;
				PlayerPawn(Driver).EndZoom();
				Driver.ClientSetRotation(Rotation);
			}
			Driver.Weapon = Driver.PendingWeapon;
			if( Driver.Weapon!=None )
				Driver.Weapon.BringUp();
		}
	}
	if( DriverGun!=None )
		DriverGun.WeaponController = None;
	if( DWeapon!=None )
	{
		DWeapon.NotifyDriverLeft(Driver);
		DWeapon.SetOwner(Self);
	}
	Driver = None;
	//SetOwner(None); Set to none 1 sec later to avoid unwanted functions errors.
	if( !bDeleteMe && Health>0 )
	{
		if( MyFactory!=None )
		{
			if( HasPassengers() )
				ResetTimer = Default.ResetTimer;
			else ResetTimer = Level.TimeSeconds+MyFactory.VehicleResetTime;
		}
		GoToState('EmptyVehicle');
	}
}
simulated function VehicleAttachment AddAttachment( class<VehicleAttachment> AttachClass )
{
	local VehicleAttachment W;

	W = Spawn(AttachClass,Self);
	if( W==None )
		Return None;
	W.OwnerVehicle = Self;
	if( AttachmentList==None )
		AttachmentList = W;
	else
	{
		W.NextAttachment = AttachmentList;
		AttachmentList = W;
	}
	Return W;
}
simulated function Destroyed()
{
	local VehicleAttachment W,NW;
	local byte i;

	if( Driver!=None )
		DriverLeft(True);
	For( i=0; i<ArrayCount(Passengers); i++ )
	{
		if( Passengers[i]!=None )
			PassengerLeave(i,True);
		if( PassengerSeats[i].PHGun!=None )
			PassengerSeats[i].PHGun.Destroy();
		if( PassengerSeats[i].PassengerCam!=None )
			PassengerSeats[i].PassengerCam.Destroy();
	}
	if( MyFactory!=None )
		MyFactory.NotifyVehicleDestroyed();
	For( W=AttachmentList; W!=None; W=NW )
	{
		NW = W.NextAttachment;
		if( W.bAutoDestroyWithVehicle )
			W.Destroy();
		else W.NotifyVehicleDestroyed();
	}
	if( MyCameraAct!=None )
		MyCameraAct.Destroy();
	if( BotAttract!=None )
	{
		BotAttract.Destroy();
		BotAttract = None;
	}
	if( DWeapon!=None )
		DWeapon.Destroy();
	Super.Destroyed();
}
// Client update vehicle pos/rot/vel
simulated function ClientUpdateState( float Delta )
{
	local float Dist;

	if( bUpdatingPos )
	{
		Move(SimPosUpd);
		UpdTimeLeft--;
		if( UpdTimeLeft==0 )
		{
			bOnGround = CheckOnGround();
			bUpdatingPos = False;
		}
	}
	if( VehPos!=vect(0,0,0) ) // Give an interpolation for location updates
	{
		Dist = VSize(VehPos-Location);
		if( Dist>350 || Dist<=5 )
		{
			bOnGround = CheckOnGround();
			bUpdatingPos = False;
			SetLocation(VehPos);
		}
		else
		{
			UpdTimeLeft = (Dist/5);
			bUpdatingPos = True;
			if( UpdTimeLeft==0 )
				UpdTimeLeft = 1;
			else if( UpdTimeLeft>50 )
				UpdTimeLeft = 50;
			SimPosUpd = (VehPos-Location)/UpdTimeLeft;
		}
	}	
	if( VehVeloc!=SimVehVeloc )
	{
		SimVehVeloc = VehVeloc;
		Velocity = VehVeloc/15.f;
	}
	if( bShouldRepVehYaw && ReplVehicleYaw!=0 )
	{
		if( bFPRepYawUpdatesView && !bCameraOnBehindView && Driver!=None && IsNetOwner(Driver) )
			Driver.ViewRotation.Yaw+=(ReplVehicleYaw-VehicleYaw);
		VehicleYaw = ReplVehicleYaw;
		ReplVehicleYaw = 0;
	}
}
// Server send to client vehicle pos/rot/vel
function ServerPackState( float Delta)
{
	VehPos = Location;
	VehVeloc = Velocity*15.f;
	if( bShouldRepVehYaw )
		ReplVehicleYaw = VehicleYaw;
}
// Main tick
simulated function Tick( float Delta )
{
	PendingBump = None;
	if( Level.NetMode==NM_Client )
	{
		if( bVehicleBlewUp )
		{
			if( !bClientBlewUp )
			{
				SpawnExplosionFX();
				bClientBlewUp = True;
			}
			Return;
		}
		ClientUpdateState(Delta);
		if( ReplicOverlayMat.MatTexture!=None )
		{
			SetOverlayMat(ReplicOverlayMat.MatTexture,float(ReplicOverlayMat.MatDispTime)/25.f);
			ReplicOverlayMat.MatTexture = None;
		}
	}
	else if( bResetOLRep && OverlayResetTime<Level.TimeSeconds )
	{
		bResetOLRep = False;
		ReplicOverlayMat.MatTexture = None;
		ReplicOverlayMat.MatDispTime = 0;
	}
	if( Level.NetMode!=NM_DedicatedServer )
	{
		if( OverlayMat!=None )
		{
			if( OverlayMActor==None )
				OverlayMActor = Spawn(Class'MatOverlayFX',Self);
			OverlayMActor.Texture = OverlayMat;
			if( OverlayTime>=1 )
				OverlayMActor.ScaleGlow = 1;
			else OverlayMActor.ScaleGlow = (OverlayTime/1);
			OverlayMActor.AmbientGlow = OverlayMActor.ScaleGlow * 255;
			OverlayTime-=Delta;
			if( OverlayTime<=0 )
				OverlayMat = None;
		}
		else if( OverlayMActor!=None )
		{
			OverlayMActor.Destroy();
			OverlayMActor = None;
		}
	}
	if( bDriving && (Level.NetMode<NM_Client || IsNetOwner(Driver)) )
	{
		if( Driver==None || ((Driver.bDeleteMe || Driver.Health<=0) && Level.NetMode<NM_Client) )
		{
			if( Level.NetMode<NM_Client )
			{
				if( Driver!=None )
					Driver.DrawScale = Driver.Default.DrawScale;
				if( Driver!=None && Driver.bDeleteMe )
					Driver = None;
				DriverLeft(True);
			}
		}
		else if( PlayerPawn(Driver)==None )
			ReadBotInput(Delta);
		else if( NetConnection(PlayerPawn(Driver).Player)==None )
			ReadDriverInput(PlayerPawn(Driver),Delta);
	}
	if( ActualFloorNormal!=FloorNormal )
	{
		// smoothly change floor
		FloorNormal = Normal(6*Delta * ActualFloorNormal + (1 - 6*Delta) * FloorNormal);
		if ( (ActualFloorNormal Dot FloorNormal) > 0.999 )
			FloorNormal = ActualFloorNormal;
	}
	bOwnerNoSee = False;
	if( Driver!=None )
		UpdateDriverPos();
	if( bOnGround && !CheckOnGround() )
		bOnGround = False;
	UpdateDriverInput(Delta);
	UpdatePassengerPos();
	if( Level.NetMode>NM_StandAlone && Level.NetMode<NM_Client )
		ServerPackState(Delta);
	if( !bIsWaterResistant && Region.Zone.bWaterZone && Level.NetMode<NM_Client && NextWaterDamageTime<Level.TimeSeconds )
	{
		NextWaterDamageTime = Level.TimeSeconds+0.25;
		TakeDamage(25,None,Location,vect(0,0,0),'drowned');
	}
}
simulated function AttachmentsTick( float Delta ); // Update attachment's location here!

// Vehicle is currently on ground?
simulated function bool CheckOnGround()
{
	local vector End,Start,Ex,HL,HN;

	Start = Location;
	Start.Z-=(CollisionHeight-1);
	End = Start;
	End.Z-=6;
	Ex.X = CollisionRadius;
	Ex.Y = Ex.X;
	if( Trace(HL,HN,End,Start,False,Ex)==None )
		Return False;
	ActualFloorNormal = HN;
	Return True;
}

// Make sure driver is directly in center of vehicle.
simulated function UpdateDriverPos()
{
	local rotator R;

	Driver.SetLocation(Location);
	Driver.Velocity = Velocity;
	if( Level.NetMode<NM_Client )
	{
		if( Driver.bCollideActors )
			Driver.SetCollision(false);
		Driver.DrawScale = 0;
		if( DriverGun!=None )
			R.Yaw = DriverGun.TurretYaw;
		else R.Yaw = Rotation.Yaw;
		Driver.SetRotation(R);
		if( PlayerPawn(Driver)==None )
			Driver.ViewRotation = R;
	}
	else Driver.SetRotation(Rotation);
	if( (Level.NetMode<NM_Client || IsNetOwner(Driver)) && Driver.Physics!=ReqPPPhysics )
		Driver.SetPhysics(ReqPPPhysics);
}
simulated function UpdatePassengerPos()
{
	local byte i;
	local rotator R;

	For( i=0; i<Arraycount(Passengers); i++ )
	{
		if( Passengers[i]!=None )
		{
			if( Passengers[i].bDeleteMe || Passengers[i].Health<=0 )
			{
				if( Level.NetMode<NM_Client )
					PassengerLeave(i,True);
				Continue;
			}
			Passengers[i].SetLocation(Location);
			Passengers[i].Velocity = Velocity;
			if( Level.NetMode<NM_Client )
			{
				if( Passengers[i].bCollideActors )
					Passengers[i].SetCollision(false);
				Passengers[i].DrawScale = 0;
				if( PassengerSeats[i].PGun!=None )
					R.Yaw = PassengerSeats[i].PGun.TurretYaw;
				else R = Rotation;
				Passengers[i].SetRotation(R);
			}
			else Passengers[i].SetRotation(Rotation);
			if( (Level.NetMode<NM_Client || IsNetOwner(Passengers[i])) && Passengers[i].Physics!=ReqPPPhysics )
				Passengers[i].SetPhysics(ReqPPPhysics);
		}
	}
}

// Update vehicle velocity/rotation as driver selects their movements
simulated function UpdateDriverInput( float Delta );

// Read whatever input driver is pressing now
simulated function ReadDriverInput( PlayerPawn Other, float DeltaTime )
{
	if( Other.bWasForward )
		Accel = 1;
	else if( Other.bWasBack )
		Accel = -1;
	else Accel = 0;
	if( Other.bWasLeft )
		Turning = -1;
	else if( Other.bWasRight )
		Turning = 1;
	else Turning = 0;
	if( Other.bDuck!=0 )
	{
		Other.bPressedJump = False;
		Rising = -1;
	}
	else if( Other.bPressedJump )
		Rising = 1;
	else Rising = 0;
	if( Level.NetMode==NM_Client )
		ServerPreformMove(byte(Rising+1),byte(Turning+1),byte(Accel+1));
	if( MyCameraAct!=None )
	{
		if( Other.bBehindView && Other.ViewTarget==MyCameraAct )
		{
			Other.bBehindView = False;
			bUseBehindView = !bUseBehindView;
			ServerSetBehindView(bUseBehindView);
			SaveConfig();
		}
		else if( bCameraOnBehindView!=bUseBehindView )
			ServerSetBehindView(bUseBehindView);
	}
}

// Update server behindview
function ServerSetBehindView( bool bNewView )
{
	bCameraOnBehindView = bNewView;
	if( PlayerPawn(Owner)!=None )
		PlayerPawn(Owner).bBehindView = False;
}

// Figure out a good move for bots
function ReadBotInput( float Delta )
{
	local vector V;

	if( !bHasMoveTarget )
	{
		bHasMoveTarget = True;
		MoveDest = VehicleAI.GetNextMoveTarget();
		V = Location-MoveDest;
		V.Z = 0;
		if( VSize(V)<100 )
		{
			Driver.MoveTimer = 0;
			Driver.MoveTarget = None;
			Driver.StopWaiting();
			bHasMoveTarget = False;
			Return;
		}
		MoveTimer = Level.TimeSeconds+2;
	}
	V = Location-MoveDest;
	V.Z = 0;
	if( MoveTimer<Level.TimeSeconds || VSize(V)<100 )
	{
		bHasMoveTarget = False;
		Return;
	}
	Turning = ShouldTurnFor(MoveDest);
	Rising = 0;
	Accel = ShouldAccelFor(MoveDest);
}

// Returns the bot value for accel target
function int ShouldAccelFor( vector AcTarget )
{
	if( (Normal(AcTarget-Location) dot vector(Rotation))>0 )
		Return 1;
	else Return -1;
}

// Returns the bot turning value for target
function int ShouldTurnFor( vector AcTarget )
{
	local vector X,Y,Z;
	local float Res;

	GetAxes(Rotation,X,Y,Z);
	Res = Normal(AcTarget-Location) dot Y;
	if( Abs(Res)<0.1 )
		Return 0;
	else if( Res>0 )
		Return -1;
	else Return 1;
}

// Pawn can enter this vehicle?
function bool CanEnter( Pawn Other, optional bool bIgnoreDuck )
{
	if( Other.Health<=0 || (!bIgnoreDuck && PlayerPawn(Other)!=None && Other.bDuck==0) || DriverWeapon(Other.Weapon)!=None )
		Return False;
	Return True;
}
function bool IsTeamLockedFor( Pawn Other )
{
	Return ((bTeamLocked || HasPassengers()) && Level.Game.bTeamGame && Level.Game.bDeathMatch && Other.PlayerReplicationInfo!=None
	 && Other.PlayerReplicationInfo.Team<=3 && Other.PlayerReplicationInfo.Team!=CurrentTeam);
}

Auto State EmptyVehicle
{
Ignores FireWeapon,ReadDriverInput,ReadBotInput,DriverLeft;

	function ServerPreformMove( byte InRise, byte InTurn, byte InAccel )
	{
		Turning = 0;
		Rising = 0;
		Accel = 0;
	}
	function MessageLocalPLs()
	{
		local Pawn P;

		For( P=Level.PawnList; P!=None; P=P.NextPawn )
		{
			if( P.bIsPlayer && PlayerPawn(P)!=None && VSize(P.Location-Location)<(CollisionRadius+100+P.CollisionRadius) && CanEnter(P,True)
			 && !IsTeamLockedFor(P) )
				P.ClientMessage("Hold 'Crouch' key to enter this"@VehicleName,'Pickup');
		}
	}
	function Bump( Actor Other )
	{
		Global.Bump(Other);
		if( Other.bDeleteMe )
			Return;
		if( !Other.bIsPawn || !CanEnter(Pawn(Other)) )
			Return;
		if( IsTeamLockedFor(Pawn(Other)) )
		{
			Pawn(Other).ClientMessage("This"@VehicleName@"is team locked.",'RedCriticalEvent');
			Return;
		}
		else if( Pawn(Other).PlayerReplicationInfo!=None && Pawn(Other).PlayerReplicationInfo.Team<=3
		 && Pawn(Other).PlayerReplicationInfo.Team!=CurrentTeam )
		{
			CurrentTeam = Pawn(Other).PlayerReplicationInfo.Team;
			SetOverlayMat(TeamOverlays[CurrentTeam],0.5);
			PlaySound(Sound'CarAlarm01',SLOT_Misc,2,,400);
			if( PlayerPawn(Other)!=None )
				PlayerPawn(Other).ClientPlaySound(Sound'Hijacked');
		}
		if( !VehicleAI.PawnCanDrive(Pawn(Other)) )
			Return;
		DriverEnter(Pawn(Other));
	}
	function BeginState()
	{
		AmbientSound = IdleSound;
		SoundPitch = Default.SoundPitch;
		bDriving = False;
		// Hit breaks on.
		Turning = 0;
		Rising = 0;
		Accel = 0;
		if( BotAttract==None )
		{
			BotAttract = Spawn(Class'BotAttractInv',Self);
			if( BotAttract!=None )
				BotAttract.VehicleOwner = Self;
		}
	}
	function EndState()
	{
		bDriving = True;
		if( BotAttract!=None )
		{
			BotAttract.Destroy();
			BotAttract = None;
		}
	}
	function Tick( float Delta )
	{
		if( ResetTimer!=Default.ResetTimer && Level.TimeSeconds>ResetTimer )
			Destroy();
		else Global.Tick(Delta);
	}
Begin:
	Sleep(Level.TimeDilation);
	if( Owner!=None )
		SetOwner(None);
	MessageLocalPLs(); // Message every second.
	GoTo'Begin';
}

State VehicleDriving
{
	function Bump( Actor Other )
	{
		local byte Fr;

		Global.Bump(Other);
		if( Other.bDeleteMe || !Other.bIsPawn || !CanAddPassenger(Pawn(Other),Fr) || !VehicleAI.PawnCanPassenge(Pawn(Other),Fr) )
			Return;
		PassengerEnter(Pawn(Other),Fr);
	}
	function Touch( Actor Other )
	{
		if( Triggers(Other)!=None && Driver!=None )
			Other.Touch(Driver);
	}
}

simulated event SetInitialState()
{
	if( Level.NetMode==NM_Client )
		Return; // Do not set a state on clients!
	if( InitialState!='' )
		GotoState( InitialState );
	else GotoState( 'Auto' );
}
simulated function ClientSetTranslatorMsg()
{
	local Inventory I;
	local int Count;
	local PlayerPawn PP;

	ServerSetBehindView(bUseBehindView);
	if( Level.NetMode==NM_DedicatedServer )
		Return;
	if( Level.NetMode==NM_Client )
	{
		ForEach AllActors(Class'PlayerPawn',PP)
		{
			if( PP.Player!=None )
				Break;
		}
	}
	else PP = PlayerPawn(Owner);
	if( PP==None )
		Return;
	PP.bBehindView = False;
	if( MyCameraAct!=None )
		PP.ViewTarget = MyCameraAct;
	PP.ClientMessage(VehicleName,'Pickup');
	For( I=PP.Inventory; (I!=None && Count<2000); I=I.Inventory )
	{
		if( Translator(I)!=None )
		{
			PP.ClientMessage(MsgVehicleDesc);
			Translator(I).NewMessage = TranslatorDescription;
			Return;
		}
		Count++;
	}
}
simulated function CalcCameraPos( out vector Pos, out rotator Rot, optional byte SeatNumber )
{
	local vector V,S,HL,HN;

	if( SeatNumber>0 )
	{
		SeatNumber--;
		if( Passengers[SeatNumber]==None )
			Rot = Rotation;
		else Rot = Passengers[SeatNumber].ViewRotation;
		bOwnerNoSee = False;
		S = Location+((PassengerSeats[SeatNumber].PassengerWOffset+PassengerSeats[SeatNumber].CameraOffset) >> Rotation);
		V = S+(PassengerSeats[SeatNumber].CamBehindviewOffset >> Rot);
		if( Trace(HL,HN,V,S,False)==None )
			Pos = V;
		else Pos = HL+HN*5;
		Return;
	}
	if( Pawn(Owner)==None )
		Rot = Rotation;
	else Rot = Pawn(Owner).ViewRotation;
	if( !bCameraOnBehindView )
	{
		Pos = Location+(InsideViewOffset >> Rotation);
		bOwnerNoSee = True;
		if( !bFPViewUseRelRot )
			Return;
		Rot = TransformForGroundRot(Rot.Yaw,FloorNormal,Rot.Pitch);
		Return;
	}
	bOwnerNoSee = False;
	V = Location+(BehinViewViewOffset >> Rot);
	if( Trace(HL,HN,V,Location,False)==None )
		Pos = V;
	else Pos = HL+HN*5;
}
function rotator GetFiringRot( float ProjSpeed, bool bInstantHit, vector PStartPos, optional byte SeatN )
{
	local vector End,Start,HL,HN;
	local rotator Aim;

	if( bInstantHit )
		ProjSpeed = 99999;
	if( SeatN>0 )
	{
		SeatN--;
		if( PlayerPawn(Passengers[SeatN])==None )
			Return Passengers[SeatN].AdjustAim(ProjSpeed,PStartPos,200,True,True);
		CalcCameraPos(Start,Aim,SeatN+1);
		End = Start+vector(Aim)*8000;
		if( Trace(HL,HN,End,Start,True)==None )
			return rotator(End-PStartPos);
		else return rotator(HL-PStartPos);
	}
	if( PlayerPawn(Driver)==None )
		Return Driver.AdjustAim(ProjSpeed,PStartPos,200,True,True);
	CalcCameraPos(Start,Aim);
	End = Start+vector(Aim)*8000;
	if( Trace(HL,HN,End,Start,True)==None )
		return rotator(End-PStartPos);
	else return rotator(HL-PStartPos);
}
simulated function vector CalcPlayerAimPos( optional byte SeatN )
{
	local vector End,Start,HL,HN;
	local rotator Aim;

	CalcCameraPos(Start,Aim,SeatN);
	End = Start+vector(Aim)*8000;
	if( Trace(HL,HN,End,Start,True)==None )
		return End;
	else return HL;
}
simulated function RenderCanvasOverlays( Canvas C, DriverCameraActor Cam, byte Seat )
{
	local float X,Y,XS,HP,XL,YL;
	local byte i,o;

	// Draw health bar:
	C.Style = 1;
	C.DrawColor.R = 25;
	C.DrawColor.G = 255;
	C.DrawColor.B = 200;
	Y = C.ClipY/6*5;
	XS = C.ClipX/3*2;
	X = C.ClipX/2-XS/2;
	C.SetPos(X,Y);
	C.DrawTile(Texture'Misc',XS,16,0,0,122,16);
	HP = float(Health)/float(Default.Health);
	C.SetPos(X,Y);
	C.DrawTile(Texture'Misc',XS*HP,16,0,16,122.f*HP,16);
	C.Font = Font'MedFont';
	C.StrLen(string(Health),XL,YL);
	C.SetPos(C.ClipX/2-XL/2,Y+5);
	C.DrawText(string(Health),False);
	if( bRenderVehicleOnFP && Seat==0 && !bCameraOnBehindView )
	{
		bOwnerNoSee = False;
		C.DrawActor(Self,False);
		bOwnerNoSee = True;
		bHidden = False;
	}

	// Draw aim OK crosshair
	if( AimLockedOnCrosshairTex!=None )
	{
		if( Seat==0 && DriverGun!=None && DriverGun.AimingIsOK() )
		{
			C.SetPos(C.ClipX/2-AimLockedOnCrosshairTex.USize/2,C.ClipY/2-AimLockedOnCrosshairTex.VSize/2);
			C.DrawColor.R = 110;
			C.DrawColor.G = 255;
			C.DrawColor.B = 110;
			C.DrawIcon(AimLockedOnCrosshairTex,1);
			DriverGun.WRenderOverlay(C);
		}
		else if( Cam!=None && Cam.GunAttachM!=None && Cam.GunAttachM.AimingIsOK() )
		{
			C.SetPos(C.ClipX/2-AimLockedOnCrosshairTex.USize/2,C.ClipY/2-AimLockedOnCrosshairTex.VSize/2);
			C.DrawColor.R = 110;
			C.DrawColor.G = 255;
			C.DrawColor.B = 110;
			C.DrawIcon(AimLockedOnCrosshairTex,1);
			Cam.GunAttachM.WRenderOverlay(C);
		}
	}
	o = CurrentTeam;
	if( o>3 )
		o = 0;
	C.DrawColor = Class'UnrealTeamScoreBoard'.Default.TeamColor[o];
	C.Font = Font'SmallFont';
	C.StrLen("ATST",XL,YL);
	if( Seat>0 && Driver!=None && Driver.PlayerReplicationInfo!=None )
	{
		C.SetPos(15,C.ClipY-50);
		C.DrawText("Driver -"@Driver.PlayerReplicationInfo.PlayerName);
		o = 1;
	}
	else o = 0;
	For( i=0; i<Arraycount(Passengers); i++ )
	{
		if( Passengers[i]!=None && Passengers[i].PlayerReplicationInfo!=None && (i+1)!=Seat )
		{
			C.SetPos(15,C.ClipY-50-YL*o);
			C.DrawText(PassengerSeats[i].SeatName@"-"@Passengers[i].PlayerReplicationInfo.PlayerName);
			o++;
		}
	}
	if( !bActorKeysInit )
		InitKeysInfo();
	XS = 34;
	For( i=0; i<NumKeysInfo; i++ )
	{
		if( KeysInfo[i]!="" )
		{
			C.TextSize(KeysInfo[i],XL,YL);
			C.SetPos(C.ClipX-XL-4,XS);
			C.DrawText(KeysInfo[i]);
			XS+=YL;
		}
	}
	
	if( AttachmentList!=None )
		AttachmentList.AddCanvasOverlay(C);
}

// This function is NOT called by engine, its for Custom Mods to render vehcle status from a third person.
simulated function DrawVehicleStatus( Canvas C, vector CameraPos, rotator CameraRot )
{
	local float RendSize,X,Y,XS,YS,XL,YL,OffS;
	local byte i;

	RendSize = VSize(CameraPos-Location)*(C.ViewPort.Actor.FovAngle/90.f);
	if( RendSize>4000 || (Driver!=None && Driver==C.ViewPort.Actor) )
		Return;
	For( i=0; i<ArrayCount(PassengerSeats); i++ )
	{
		if( Passengers[i]!=None && Passengers[i]==C.ViewPort.Actor )
			Return;
	}
	RendSize/=4000;
	RendSize = 1.1-RendSize;
	if( RendSize>1 )
		RendSize = 1;
	C.Style = 1;
	XS = 75.f*RendSize;
	YS = 8.f*RendSize;
	if( !bDriving )
	{
		if( bTeamLocked && C.ViewPort.Actor.PlayerReplicationInfo!=None && !C.ViewPort.Actor.PlayerReplicationInfo.bIsSpectator
		 && C.ViewPort.Actor.PlayerReplicationInfo.Team<=3 && C.ViewPort.Actor.PlayerReplicationInfo.Team!=CurrentTeam
		 && WorldToScreen(Location,C.ViewPort.Actor,CameraPos,CameraRot,C.ClipX,C.ClipY,X,Y) )
		{
			C.DrawColor.R = 255;
			C.DrawColor.G = 0;
			C.DrawColor.B = 0;
			C.SetPos(X-16f*RendSize,Y-16f*RendSize);
			C.DrawIcon(Texture'IconNoEnter',RendSize/2);
		}
		if( WorldToScreen(Location+vect(0,0,1)*CollisionHeight,C.ViewPort.Actor,CameraPos,CameraRot,C.ClipX,C.ClipY,X,Y) )
			DrawHealthBar(C,Health,Default.Health,X,Y-YS,XS,YS);
		if( CurrentTeam<=3 )
		{
			C.DrawColor = Class'UnrealTeamScoreBoard'.Default.TeamColor[CurrentTeam];
			C.Font = Font'SmallFont';
			For( i=0; i<ArrayCount(PassengerSeats); i++ )
			{
				if( Passengers[i]!=None && Passengers[i].PlayerReplicationInfo!=None )
				{
					C.StrLen(Passengers[i].PlayerReplicationInfo.PlayerName,XL,YL);
					C.SetPos(X-XL/2,Y-YS-YL-1-OffS);
					OffS+=YL;
					C.DrawTextClipped(Passengers[i].PlayerReplicationInfo.PlayerName);
				}
			}
		}
	}
	else if( C.ViewPort.Actor.PlayerReplicationInfo!=None && (C.ViewPort.Actor.PlayerReplicationInfo.bIsSpectator
	 || (C.ViewPort.Actor.PlayerReplicationInfo.Team<=3 && C.ViewPort.Actor.PlayerReplicationInfo.Team==CurrentTeam))
	 && WorldToScreen(Location+vect(0,0,1)*CollisionHeight*1.1,C.ViewPort.Actor,CameraPos,CameraRot,C.ClipX,C.ClipY,X,Y) )
	{
		C.DrawColor = Class'UnrealTeamScoreBoard'.Default.TeamColor[CurrentTeam];
		C.Font = Font'SmallFont';
		if( Driver!=None && Driver.PlayerReplicationInfo!=None )
		{
			C.StrLen(Driver.PlayerReplicationInfo.PlayerName,XL,YL);
			C.SetPos(X-XL/2,Y-YS-YL-1);
			C.DrawTextClipped(Driver.PlayerReplicationInfo.PlayerName);
			OffS = YL;
		}
		For( i=0; i<ArrayCount(PassengerSeats); i++ )
		{
			if( Passengers[i]!=None && Passengers[i].PlayerReplicationInfo!=None )
			{
				C.StrLen(Passengers[i].PlayerReplicationInfo.PlayerName,XL,YL);
				C.SetPos(X-XL/2,Y-YS-YL-1-OffS);
				OffS+=YL;
				C.DrawTextClipped(Passengers[i].PlayerReplicationInfo.PlayerName);
			}
		}
		DrawHealthBar(C,Health,Default.Health,X,Y-YS,XS,YS);
	}
}
simulated function DrawHealthBar(Canvas C, int Health, int MaxHealth, int X, int Y, float HBWeight, float HBHeight )
{
	local float			HealthPct;

	if( Health>MaxHealth )
		Health = MaxHealth;

	C.DrawColor.R = 255;
	C.DrawColor.G = 255;
	C.DrawColor.B = 255;

	C.SetPos(X - HBWeight*0.5, Y);
	C.DrawTile(Texture'BorderBoxD',HBWeight,HBHeight,0,0,64,64);
	
	HealthPct = 1.0f * Health / MaxHealth;
	
	if (HealthPct < 0.35)
	{
		C.DrawColor.G = 0;
		C.DrawColor.B = 0;
	}
	else if (HealthPct < 0.70)
		C.DrawColor.B = 0;
	else
	{
		C.DrawColor.R = 0;
		C.DrawColor.B = 0;
	}
	
	C.SetPos(X - HBWeight * 0.5, Y);
	C.DrawTile(Texture'HealthBar',HBWeight * HealthPct, HBHeight,0,0,64,64);
}
simulated function Bump( Actor Other )
{
	local vector OtVel,MyVel,Dir;
	local float Sp;

	if( Vehicle(Other)!=None )
	{
		if( PendingBump==Other )
			Return; // Just bumped...
		OtVel = Other.Velocity;
		MyVel = Velocity;
		Sp = VSize(Velocity);
		if( Sp>350 )
			Other.TakeDamage((Sp-300)/10,Instigator,Location,Velocity*Mass,'Crushed');
		Sp = VSize(OtVel);
		if( Sp>350 )
			TakeDamage((Sp-300)/10,Other.Instigator,Other.Location,OtVel*Other.Mass,'Crushed');
		Dir = Normal(Other.Location-Location);
		Vehicle(Other).PendingBump = Self;
		if( (Normal(Velocity) Dot Dir)>0 ) // We are running into other vehicle.
		{
			Velocity = SetUpNewMVelocity(MyVel,Normal(Location-Other.Location),0.35);
			if( (Normal(Other.Velocity) Dot Dir)<0 ) // Other vehicle is moving into us aswell.
			{
				Other.Velocity = SetUpNewMVelocity(OtVel,Normal(Other.Location-Location),0.35);
				Sp = VSize(MyVel)+VSize(OtVel);
			}
			else
			{
				//Other.Velocity-=(MirrorVectorByNormal(MyVel*0.8,Dir)/FMin(VSize(Velocity),100));
				//Other.Velocity+=(MyVel*FClamp((Mass/Other.Mass)*0.8,0,1.5));
				Sp = VSize(MyVel)-VSize(OtVel);
			}
		}
		else // Other vehicle ran into us from behind.
		{
			//Velocity-=(MirrorVectorByNormal(OtVel*0.8,-Dir)/FMin(VSize(Velocity),100));
			//Velocity+=(OtVel*FClamp((Other.Mass/Mass)*0.8,0,1.5));
			Other.Velocity = SetUpNewMVelocity(OtVel,Normal(Other.Location-Location),0.35);
			Sp = VSize(MyVel)-VSize(OtVel);
		}
		if( Sp>500 )
		{
			Sp = (Sp-500)/20;
			Vehicle(Other).TakeImpactDamage(Sp,Instigator);
			TakeImpactDamage(Sp,Other.Instigator);
		}
	}
	else if( (Normal(Velocity) Dot Normal(Other.Location-Location))>0 ) // We ran into this object.
	{
		if( VSize(Velocity)>200 )
			Other.TakeDamage((VSize(Velocity)-100)/7*Mass/500.f,Instigator,Other.Location+Normal(Location-Other.Location)*Other.CollisionRadius
			 ,Velocity*Other.Mass,'Crushed');
		if( !Other.bStatic && Other.bMovable && ((Other.IsA('Decoration') && Decoration(Other).bPushable) || Other.bIsPawn) )
			Velocity = SetUpNewMVelocity(Velocity,Normal(Location-Other.Location),-1+FClamp(0.9*(Other.Mass/Mass*1.5),0,0.9f));
		else Velocity = SetUpNewMVelocity(Velocity,Normal(Location-Other.Location),0.1);
	}
}
simulated singular function HitWall( vector HitNormal, Actor Wall )
{
	local vector V;
	local float BMulti,VSpee;

	MoveSmooth(HitNormal);
	V = SetUpNewMVelocity(Velocity,HitNormal,1);
	if( !bOnGround && HitNormal.Z>0.8 )
	{
		if( VSize(Normal(V)-Normal(Velocity))>0.85 && VSize(Velocity)>450 )
		{
			Velocity = SetUpNewMVelocity(Velocity,HitNormal,0.15);
			Return;
		}
		bOnGround = True;
		ActualFloorNormal = HitNormal;
		Velocity = SetUpNewMVelocity(Velocity,HitNormal,0);
		Return;
	}
	if( VSize(Normal(V)-Normal(Velocity))>0.85 || (bOnGround && !CanYawUpTo(Rotation,TransformForGroundRot(VehicleYaw,HitNormal),1500)) )
	{
		if( bOnGround && CanGetOver(35,0.85) )
			Return;
		bOnGround = False;
		V = Velocity;
		if( (Normal(Velocity) Dot HitNormal)>0 )
			Velocity = SetUpNewMVelocity(Velocity,HitNormal,0.5);
		else Velocity = SetUpNewMVelocity(Velocity,HitNormal,0.05);
		if( Wall!=Level && Wall.Brush==None )
			Return;
		BMulti = (Normal(V) Dot Normal(Velocity));
		VSpee = VSize(V);
		if( VSpee>500 && BMulti<-0.2 )
			TakeImpactDamage((VSpee-500)/4,None);
		else if( VSpee>600 && BMulti<0 )
			TakeImpactDamage((VSpee-600)/4.5,None);
		else if( VSpee>1300 && BMulti<0.3 )
			TakeImpactDamage((VSpee-1300)/5,None);
	}
	else
	{
		Velocity = SetUpNewMVelocity(Velocity,HitNormal,0);
		ActualFloorNormal = HitNormal;
		bOnGround = True;
	}
}
simulated function TakeImpactDamage( int Damage, Pawn InstigatedBy )
{
	if( Level.NetMode!=NM_DedicatedServer )
		PlaySound(ImpactSounds[Rand(ArrayCount(ImpactSounds))],SLOT_Pain,FClamp(float(Damage)/50,0.75,2));
	TakeDamage(Damage,InstigatedBy,Location,vect(0,0,0),'BumpWall');
}
function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation,
						Vector momentum, name damageType)
{
	local byte i;
	local bool bHadPass;

	if( bDeleteMe || Level.NetMode==NM_Client )
		Return;
	if( Driver==None )
	{
		For( i=0; i<Arraycount(Passengers); i++ )
		{
			if( Passengers[i]!=None )
			{
				bHadPass = True;
				Damage = Level.Game.ReduceDamage(Damage,DamageType,Passengers[i],instigatedBy);
				Break;
			}
		}
		if( !bHadPass && instigatedBy!=None && instigatedBy.PlayerReplicationInfo!=None && CurrentTeam==instigatedBy.PlayerReplicationInfo.Team )
			Damage = 0;
	}
	else if( Driver.ReducedDamageType=='All' ) // God mode on!
		Damage = 0;
	else Damage = Level.Game.ReduceDamage(Damage,DamageType,Driver, instigatedBy);
	if( Driver!=None )
		Driver.damageAttitudeTo(instigatedBy);
	For( i=0; i<Arraycount(Passengers); i++ )
	{
		if( Passengers[i]!=None )
			Passengers[i].damageAttitudeTo(instigatedBy);
	}
	if( damageType!='BumpWall' )
		PlaySound(BulletHitSounds[Rand(ArrayCount(BulletHitSounds))],SLOT_Pain,FClamp(float(Damage)/20,0.75,2));
	Health-=Damage;
	Velocity+=momentum/Mass;
	if( Health<=0 )
	{
		KillDriver(instigatedBy);
		GoToState('BlownUp');
	}
}

State BlownUp
{
Ignores TakeDamage,DriverEnter,Tick,ServerPackState,Bump;

	function PassengerEnter( Pawn Other, byte Seat );

Begin:
	bVehicleBlewUp = True;
	if( Level.NetMode!=NM_DedicatedServer )
		SpawnExplosionFX();
	Sleep(0.25);
	Destroy();
}

function KillDriver( Pawn Killer )
{
	local Pawn D;
	local byte i;

	if( Driver!=None )
	{
		D = Driver;
		DriverLeft(True);
		D.Died(Killer,'Gibbed',Location);
	}
	For( i=0; i<ArrayCount(Passengers); i++ )
	{
		if( Passengers[i]!=None )
		{
			D = Passengers[i];
			PassengerLeave(i,True);
			D.Died(Killer,'Gibbed',Location);
		}
	}
}

simulated function SpawnExplosionFX()
{
	local SilentBallExplosion S;
	local VehicleAttachment W,NW;
	local TornOffCarPartActor WT;
	local byte i;
	local Fragment Fr;

	S = Spawn(Class'SilentBallExplosion');
	if( S==None )
		Return;
	S.DrawScale*=CollisionRadius/10;

	if( Level.NetMode!=NM_DedicatedServer )
	{
		for( i=Rand(10); i<20; i++ )
		{
			Fr = Spawn(Class'Fragment1',,,Location+VRand()*CollisionHeight);
			If (Fr!=none && !Fr.bdeleteme)
			{
				Fr.CalcVelocity(Velocity+VRand()*800,0);
				Fr.Skin = texture'JSteelBarrel2';
				Fr.DrawScale = 0.5+1.5*FRand();
			}
		}
	}
	PlaySound(Sound'Explo1',SLOT_Pain,2);
	PlaySound(Sound'Explo1',SLOT_Misc,2);
	SetCollision(False,False,False);
	bHidden = True;
	bMovable = False;
	For( W=AttachmentList; W!=None; W=NW )
	{
		NW = W.NextAttachment;
		if( W.bAutoDestroyWithVehicle )
		{
			if( Level.NetMode!=NM_DedicatedServer ) // Make these parts "fly off" with the vehicle.
			{
				WT = Spawn(Class'TornOffCarPartActor',Self,,W.Location,W.Rotation);
				WT.CopyDisplayFrom(W);
			}
			W.Destroy();
		}
		else W.NotifyVehicleDestroyed();
	}
	AttachmentList = None;
}
simulated function SetOverlayMat( Texture MatTex, float MatDispTime )
{
	if( Level.NetMode>NM_StandAlone && Level.NetMode<NM_Client )
	{
		ReplicOverlayMat.MatTexture = MatTex;
		ReplicOverlayMat.MatDispTime = byte(MatDispTime*25.f);
		bResetOLRep = True;
		OverlayResetTime = Level.TimeSeconds+0.25;
	}
	if( Level.NetMode!=NM_DedicatedServer )
	{
		OverlayMat = MatTex;
		OverlayTime = MatDispTime;
	}
}

// Called whenever driver or passenger wants to change seat.
function ChangeSeat( byte SeatNum, bool bWasPassenger, byte PassengerNum )
{
	local Pawn InvPawn,OthPawn;

	if( !bWasPassenger )
		InvPawn = Driver;
	else InvPawn = Passengers[PassengerNum];
	if( PlayerPawn(InvPawn)==None || SeatNum>ArrayCount(PassengerSeats) || (SeatNum>0 && !PassengerSeats[SeatNum-1].bIsAvailable) )
		Return;
	if( SeatNum==0 )
	{
		if( !bWasPassenger )
			Return;
		if( bDriving )
		{
			if( PlayerPawn(Driver)!=None )
				Return;
			// Allow player swap places with bots!
			OthPawn = Driver;
			DriverLeft(True);
			PassengerLeave(PassengerNum,True);
			DriverEnter(InvPawn);
			PassengerEnter(OthPawn,PassengerNum);
		}
		else
		{
			PassengerLeave(PassengerNum,True);
			DriverEnter(InvPawn);
		}
	}
	else
	{
		if( (bWasPassenger && (PassengerNum+1)==SeatNum) )
			Return;
		if( !PassengerSeatAvailable(SeatNum-1) )
		{
			if( PlayerPawn(Passengers[SeatNum-1])!=None )
				Return;
			if( bWasPassenger )
				PassengerLeave(PassengerNum,True);
			else DriverLeft(True);
			OthPawn = Passengers[SeatNum-1];
			PassengerLeave(SeatNum-1,True);
			PassengerEnter(InvPawn,SeatNum-1);
			if( bWasPassenger )
				PassengerEnter(OthPawn,PassengerNum);
			else DriverEnter(OthPawn);
		}
		else
		{
			if( bWasPassenger )
				PassengerLeave(PassengerNum,True);
			else DriverLeft(True);
			PassengerEnter(InvPawn,SeatNum-1);
		}
	}
}

function bool CanAddPassenger( Pawn Other, optional out byte FreeSlot )
{
	local byte i;

	if( !CanEnter(Other) || (Level.Game.bDeathMatch && !Level.Game.bTeamGame) )
		Return False;
	if( Level.Game.bTeamGame && Level.Game.bDeathMatch && Driver.PlayerReplicationInfo!=None )
	{
		if( Other.PlayerReplicationInfo==None || Other.PlayerReplicationInfo.Team!=Driver.PlayerReplicationInfo.Team )
			Return False;
	}
	For( i=0; i<ArrayCount(PassengerSeats); i++ )
	{
		if( PassengerSeats[i].bIsAvailable && Passengers[i]==None )
		{
			FreeSlot = i;
			Return True;
		}
	}
	Return False;
}
function bool HasPassengers()
{
	local byte i;

	For( i=0; i<ArrayCount(PassengerSeats); i++ )
	{
		if( PassengerSeats[i].bIsAvailable && Passengers[i]!=None )
			Return True;
	}
	Return False;
}
function bool HasFreePassengerSeat( optional out byte SeatNum )
{
	local byte i;

	For( i=0; i<ArrayCount(PassengerSeats); i++ )
	{
		if( PassengerSeats[i].bIsAvailable && Passengers[i]==None )
		{
			SeatNum = i;
			Return True;
		}
	}
	Return False;
}
function bool PassengerSeatAvailable( byte SNum )
{
	if( SNum>=ArrayCount(PassengerSeats) )
		Return False;
	Return (PassengerSeats[SNum].bIsAvailable && Passengers[SNum]==None);
}
function PassengerEnter( Pawn Other, byte Seat )
{
	local rotator R;

	Other.DrawScale = 0;
	Other.SetCollision(False,False,False);
	Other.SetCollisionSize(0,0);
	Passengers[Seat] = Other;
	if( PassengerSeats[Seat].PGun!=None )
	{
		PassengerSeats[Seat].PGun.WeaponController = Other;
		PassengerSeats[Seat].PGun.SetOwner(Other);
	}
	if( PassengerSeats[Seat].PHGun==None )
	{
		PassengerSeats[Seat].PHGun = Spawn(DriverWeaponClass,Other);
		PassengerSeats[Seat].PHGun.VehicleOwner = Self;
		PassengerSeats[Seat].PHGun.bPassengerGun = True;
		PassengerSeats[Seat].PHGun.SeatNumber = Seat;
	}
	else PassengerSeats[Seat].PHGun.SetOwner(Other);
	PassengerSeats[Seat].PHGun.NotifyNewDriver(Other);
	if( Other.Weapon!=None )
	{
		Other.PendingWeapon = Other.Weapon;
		Other.Weapon.GoToState('');
	}
	Other.Weapon = PassengerSeats[Seat].PHGun;
	if( PlayerPawn(Other)!=None )
	{
		Other.ClientMessage(PassengerSeats[Seat].SeatName,'Pickup');
		if( PassengerSeats[Seat].PGun!=None )
			R.Yaw = PassengerSeats[Seat].PGun.TurretYaw;
		else R.Yaw = VehicleYaw;
		R.Pitch = -4000;
		PlayerPawn(Other).ClientSetRotation(R);
		if( PassengerSeats[Seat].PassengerCam==None )
		{
			PassengerSeats[Seat].PassengerCam = Spawn(Class'PassengerCameraA',Other);
			PassengerSeats[Seat].PassengerCam.VehicleOwner = Self;
			PassengerSeats[Seat].PassengerCam.SeatNum = Seat+1;
			PassengerSeats[Seat].PassengerCam.GunAttachM = PassengerSeats[Seat].PGun;
		}
		else PassengerSeats[Seat].PassengerCam.SetOwner(Other);
		PlayerPawn(Other).ViewTarget = PassengerSeats[Seat].PassengerCam;
		PlayerPawn(Other).bBehindView = False;
		Other.GoToState('PlayerFlying');
	}
}
function PassengerLeave( byte Seat, optional bool bForcedLeave )
{
	if( Passengers[Seat]!=None )
	{
		if( Passengers[Seat].bDeleteMe )
			Passengers[Seat] = None;
		else
		{
			Passengers[Seat].DrawScale = Passengers[Seat].Default.DrawScale;
			if( PlayerPawn(Passengers[Seat])!=None && Passengers[Seat].Health>0 )
				Passengers[Seat].GoToState('PlayerWalking');
			Passengers[Seat].ClientRestart();
			Passengers[Seat].SetCollision(True,False,False);
			Passengers[Seat].SetCollisionSize(Passengers[Seat].Default.CollisionRadius,Passengers[Seat].Default.CollisionHeight);
			if( !bForcedLeave && !Passengers[Seat].SetLocation(Location+(ExitOffset >> Rotation)) )
			{
				Passengers[Seat].SetCollision(False,False,False);
				Passengers[Seat].SetCollisionSize(0,0);
				if( PlayerPawn(Passengers[Seat])!=None )
					Passengers[Seat].GoToState('PlayerFlying');
				Return;
			}
			Passengers[Seat].SetCollision(True,True,True);
			if( PlayerPawn(Passengers[Seat])!=None )
			{
				PlayerPawn(Passengers[Seat]).ViewTarget = None;
				PlayerPawn(Passengers[Seat]).EndZoom();
				Passengers[Seat].ClientSetRotation(Rotation);
			}
			Passengers[Seat].Weapon = Passengers[Seat].PendingWeapon;
			if( Passengers[Seat].Weapon!=None )
				Passengers[Seat].Weapon.BringUp();
		}
	}
	if( PassengerSeats[Seat].PGun!=None )
	{
		PassengerSeats[Seat].PGun.WeaponController = None;
		PassengerSeats[Seat].PGun.SetOwner(None);
	}
	if( PassengerSeats[Seat].PHGun!=None )
	{
		PassengerSeats[Seat].PHGun.NotifyDriverLeft(Driver);
		PassengerSeats[Seat].PHGun.SetOwner(None);
	}
	if( PassengerSeats[Seat].PassengerCam!=None && PassengerSeats[Seat].PassengerCam.Owner!=None )
		PassengerSeats[Seat].PassengerCam.SetOwner(None);
	Passengers[Seat] = None;
	if( MyFactory!=None )
	{
		if( Driver!=None || HasPassengers() )
			ResetTimer = Default.ResetTimer;
		else ResetTimer = Level.TimeSeconds+MyFactory.VehicleResetTime;
	}
}
function PassengerFireWeapon( bool bAltFire, byte Seat )
{
	local byte i;

	if( PassengerSeats[Seat].PGun==None )
		Return;
	if( bAltFire )
		i = 1;
	PassengerSeats[Seat].PGun.FireTurret(i);
}
simulated function vector GetPassengerWOffset( byte Seat )
{
	Return Location+(PassengerSeats[Seat].PassengerWOffset >> Rotation);
}

// AI hint.
function bool IsWorthyPassengerSeats()
{
	local byte i;

	For( i=0; i<8; i++ )
	{
		if( PassengerSeats[i].bIsAvailable && Passengers[i]==None )
			Return (PassengerSeats[i].PGun!=None); // We don't want to enter empty passenger seats!
	}
}

// Returns the AVRiL rocket aim position
simulated function vector GetAimPosition()
{
	Return Location;
}

defaultproperties
{
				AIRating=1.000000
				VehicleGravityScale=1.000000
				WAccelRate=250.000000
				Health=100
				AIClass=Class'CSR.VAIBehaviour'
				DriverWeaponClass=Class'CSR.DriverWeapon'
				bTeamLocked=True
				bShouldRepVehYaw=True
				VehicleName="Vehicle"
				MsgVehicleDesc="Press F2, to bring up your translator with vehicle description."
				ExitOffset=(Y=45.000000)
				BehinViewViewOffset=(X=-650.000000,Z=120.000000)
				InsideViewOffset=(X=5.000000,Y=-15.000000)
				ImpactSounds(0)=Sound'CSR.Impacts.VehicleCollision01'
				ImpactSounds(1)=Sound'CSR.Impacts.VehicleCollision02'
				ImpactSounds(2)=Sound'CSR.Impacts.VehicleCollision03'
				ImpactSounds(3)=Sound'CSR.Impacts.VehicleCollision04'
				ImpactSounds(4)=Sound'CSR.Impacts.VehicleCollision05'
				ImpactSounds(5)=Sound'CSR.Impacts.VehicleCollision06'
				ImpactSounds(6)=Sound'CSR.Impacts.VehicleCollision07'
				BulletHitSounds(0)=Sound'CSR.Impacts.VehicleHitBullet01'
				BulletHitSounds(1)=Sound'CSR.Impacts.VehicleHitBullet02'
				BulletHitSounds(2)=Sound'CSR.Impacts.VehicleHitBullet03'
				BulletHitSounds(3)=Sound'CSR.Impacts.VehicleHitBullet04'
				BulletHitSounds(4)=Sound'CSR.Impacts.VehicleHitBullet05'
				BulletHitSounds(5)=Sound'CSR.Impacts.VehicleHitBullet06'
				bUseBehindView=True
				TeamOverlays(0)=FireTexture'UnrealShare.Belt_fx.ShieldBelt.RedShield'
				TeamOverlays(1)=FireTexture'UnrealShare.Belt_fx.ShieldBelt.BlueShield'
				TeamOverlays(2)=FireTexture'UnrealShare.Belt_fx.ShieldBelt.Greenshield'
				TeamOverlays(3)=FireTexture'UnrealShare.Belt_fx.ShieldBelt.N_Shield'
				AimLockedOnCrosshairTex=Texture'CSR.HUD.CrCorrectAim'
				PassengerSeats(0)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(1)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(2)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(3)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(4)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(5)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(6)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				PassengerSeats(7)=(CamBehindviewOffset=(X=-80.000000,Z=30.000000),SeatName="Passenger Seat")
				FloorNormal=(Z=1.000000)
				ActualFloorNormal=(Z=1.000000)
				bCameraOnBehindView=True
				ResetTimer=-1.000000
				bCanTeleport=True
				Physics=PHYS_Projectile
				RemoteRole=ROLE_SimulatedProxy
				bCollideActors=True
				bCollideWorld=True
				bBlockActors=True
				bBlockPlayers=True
				bProjTarget=True
				bBounce=True
				Mass=900.000000
}
